Index: arch/sparc64/prom/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/Makefile	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/prom/Makefile	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-# $Id: Makefile,v 1.1 2004/07/22 19:49:21 joff Exp $
+# $Id: Makefile,v 1.2 2004/08/04 01:26:18 joff Exp $
 # Makefile for the Sun Boot PROM interface library under
 # Linux.
 #
Index: arch/sparc64/prom/bootstr.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/bootstr.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/bootstr.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/prom/bootstr.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: bootstr.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: bootstr.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * bootstr.c:  Boot string/argument acquisition from the PROM.
  *
  * Copyright(C) 1995 David S. Miller (davem@caip.rutgers.edu)
@@ -15,16 +15,22 @@
  */
 
 #define BARG_LEN  256
-int bootstr_len = BARG_LEN;
-static int bootstr_valid = 0;
-static char bootstr_buf[BARG_LEN] = { 0 };
+struct {
+	int bootstr_len;
+	int bootstr_valid;
+	char bootstr_buf[BARG_LEN];
+} bootstr_info = {
+	.bootstr_len = BARG_LEN,
+};
 
 char * __init
 prom_getbootargs(void)
 {
 	/* This check saves us from a panic when bootfd patches args. */
-	if (bootstr_valid) return bootstr_buf;
-	prom_getstring(prom_chosen_node, "bootargs", bootstr_buf, BARG_LEN);
-	bootstr_valid = 1;
-	return bootstr_buf;
+	if (bootstr_info.bootstr_valid)
+		return bootstr_info.bootstr_buf;
+	prom_getstring(prom_chosen_node, "bootargs",
+		       bootstr_info.bootstr_buf, BARG_LEN);
+	bootstr_info.bootstr_valid = 1;
+	return bootstr_info.bootstr_buf;
 }
Index: arch/sparc64/prom/console.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/console.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/console.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/prom/console.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: console.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: console.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * console.c: Routines that deal with sending and receiving IO
  *            to/from the current console device using the PROM.
  *
Index: arch/sparc64/prom/devops.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/devops.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/devops.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/prom/devops.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: devops.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: devops.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * devops.c:  Device operations using the PROM.
  *
  * Copyright (C) 1995 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc64/prom/init.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/init.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/init.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/prom/init.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: init.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: init.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * init.c:  Initialize internal variables used by the PROM
  *          library functions.
  *
@@ -36,6 +36,7 @@
 	int ints[3];
 	int node;
 	int i = 0;
+	int bufadjust;
 
 	prom_vers = PROM_P1275;
 
@@ -63,9 +64,19 @@
 	if (strncmp (buffer, "OBP ", 4))
 		goto strange_version;
 
-	/* Version field is expected to be 'OBP xx.yy.zz date...' */
+	/*
+	 * Version field is expected to be 'OBP xx.yy.zz date...'
+	 * However, Sun can't stick to this format very well, so
+	 * we need to check for 'OBP  xx.yy.zz date...' and adjust
+	 * accordingly. -spot
+	 */
+
+	if (strncmp (buffer, "OBP  ", 5))
+		bufadjust = 4;
+	else
+		bufadjust = 5;
 
-	p = buffer + 4;
+	p = buffer + bufadjust;
 	while (p && isdigit(*p) && i < 3) {
 		ints[i++] = simple_strtoul(p, NULL, 0);
 		if ((p = strchr(p, '.')) != NULL)
@@ -77,7 +88,7 @@
 	prom_rev = ints[1];
 	prom_prev = (ints[0] << 16) | (ints[1] << 8) | ints[2];
 
-	printk ("PROMLIB: Sun IEEE Boot Prom %s\n", buffer + 4);
+	printk ("PROMLIB: Sun IEEE Boot Prom %s\n", buffer + bufadjust);
 
 	prom_meminit();
 
Index: arch/sparc64/prom/map.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/map.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/map.S	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/prom/map.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: map.S,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: map.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * map.S: Tricky coding required to fixup the kernel OBP maps
  *	  properly.
  *
Index: arch/sparc64/prom/memory.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/memory.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/memory.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/prom/memory.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: memory.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: memory.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * memory.c: Prom routine for acquiring various bits of information
  *           about RAM on the machine, both virtual and physical.
  *
Index: arch/sparc64/prom/misc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/misc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/misc.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/prom/misc.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: misc.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: misc.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * misc.c:  Miscellaneous prom functions that don't belong
  *          anywhere else.
  *
Index: arch/sparc64/prom/p1275.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/p1275.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/p1275.c	22 Jul 2004 19:49:21 -0000	1.1
+++ arch/sparc64/prom/p1275.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: p1275.c,v 1.1 2004/07/22 19:49:21 joff Exp $
+/* $Id: p1275.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * p1275.c: Sun IEEE 1275 PROM low level interface routines
  *
  * Copyright (C) 1996,1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/prom/printf.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/printf.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/printf.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/prom/printf.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: printf.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: printf.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * printf.c:  Internal prom library printf facility.
  *
  * Copyright (C) 1995 David S. Miller (davem@caip.rutgers.edu)
Index: arch/sparc64/prom/tree.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/prom/tree.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/prom/tree.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/prom/tree.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: tree.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: tree.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * tree.c: Basic device tree traversal/scanning for the Linux
  *         prom library.
  *
Index: arch/sparc64/solaris/conv.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/conv.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/conv.h	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/conv.h	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: conv.h,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: conv.h,v 1.2 2004/08/04 01:26:18 joff Exp $
  * conv.h: Utility macros for Solaris emulation
  *
  * Copyright (C) 1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/entry64.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/entry64.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/entry64.S	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/entry64.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: entry64.S,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: entry64.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * entry64.S:  Solaris syscall emulation entry point.
  *
  * Copyright (C) 1996,1997,1998 Jakub Jelinek   (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/fs.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/fs.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/fs.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/fs.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: fs.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: fs.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * fs.c: fs related syscall emulation for Solaris
  *
  * Copyright (C) 1997,1998 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/ioctl.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/ioctl.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/ioctl.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/ioctl.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: ioctl.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: ioctl.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * ioctl.c: Solaris ioctl emulation.
  *
  * Copyright (C) 1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/ipc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/ipc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/ipc.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/ipc.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: ipc.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: ipc.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * ipc.c: Solaris IPC emulation
  *
  * Copyright (C) 1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/misc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/misc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/misc.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/misc.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: misc.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: misc.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * misc.c: Miscelaneous syscall emulation for Solaris
  *
  * Copyright (C) 1997,1998 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/signal.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/signal.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/signal.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/signal.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: signal.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: signal.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * signal.c: Signal emulation for Solaris
  *
  * Copyright (C) 1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/signal.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/signal.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/signal.h	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/signal.h	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: signal.h,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: signal.h,v 1.2 2004/08/04 01:26:18 joff Exp $
  * signal.h: Signal emulation for Solaris
  *
  * Copyright (C) 1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/socket.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/socket.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/socket.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/socket.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: socket.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: socket.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * socket.c: Socket syscall emulation for Solaris 2.6+
  *
  * Copyright (C) 1998 Jakub Jelinek (jj@ultra.linux.cz)
Index: arch/sparc64/solaris/socksys.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/socksys.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/socksys.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/socksys.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: socksys.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: socksys.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * socksys.c: /dev/inet/ stuff for Solaris emulation.
  *
  * Copyright (C) 1997 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/socksys.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/socksys.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/socksys.h	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/socksys.h	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: socksys.h,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: socksys.h,v 1.2 2004/08/04 01:26:18 joff Exp $
  * socksys.h: Definitions for STREAMS modules emulation code.
  *
  * Copyright (C) 1998 Patrik Rak (prak3264@ss1000.ms.mff.cuni.cz)
Index: arch/sparc64/solaris/systbl.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/systbl.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/systbl.S	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/systbl.S	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: systbl.S,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: systbl.S,v 1.2 2004/08/04 01:26:18 joff Exp $
  * systbl.S: System call entry point table for Solaris compatibility.
  *
  * Copyright (C) 1997,1998 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
Index: arch/sparc64/solaris/timod.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sparc64/solaris/timod.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sparc64/solaris/timod.c	22 Jul 2004 19:49:22 -0000	1.1
+++ arch/sparc64/solaris/timod.c	4 Aug 2004 01:26:18 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: timod.c,v 1.1 2004/07/22 19:49:22 joff Exp $
+/* $Id: timod.c,v 1.2 2004/08/04 01:26:18 joff Exp $
  * timod.c: timod emulation.
  *
  * Copyright (C) 1998 Patrik Rak (prak3264@ss1000.ms.mff.cuni.cz)
Index: arch/x86_64/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/x86_64/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/x86_64/Makefile	22 Jul 2004 19:49:25 -0000	1.1
+++ arch/x86_64/Makefile	4 Aug 2004 01:26:18 -0000	1.2
@@ -19,7 +19,7 @@
 # 20010105  Andi Kleen, add IA32 compiler.
 #           ....and later removed it again....
 #
-# $Id: Makefile,v 1.1 2004/07/22 19:49:25 joff Exp $
+# $Id: Makefile,v 1.2 2004/08/04 01:26:18 joff Exp $
 
 #
 # early bootup linking needs 32bit. You can either use real 32bit tools
@@ -38,6 +38,8 @@
 LDFLAGS=-e stext
 LINKFLAGS =-T $(TOPDIR)/arch/x86_64/vmlinux.lds $(LDFLAGS)
 
+check_gcc = $(shell if $(CC) $(1) -S -o /dev/null -xc /dev/null > /dev/null 2>&1 ; then echo "$(1)"; else echo "$(2)"; fi)
+
 CFLAGS += -mno-red-zone
 CFLAGS += -mcmodel=kernel
 CFLAGS += -pipe
@@ -46,13 +48,20 @@
 CFLAGS += -finline-limit=2000
 # needed for earlier gcc 3.1
 CFLAGS += -fno-strength-reduce
+CFLAGS += -Wno-sign-compare
 #CFLAGS += -g
 ifneq ($(CONFIG_X86_REMOTE_DEBUG),y)
 CFLAGS += -fno-asynchronous-unwind-tables
 endif
+# this is needed right now for the 32bit ioctl code
+CFLAGS += $(call check_gcc,-fno-unit-at-a-time,)
 
-# prevent gcc from keeping the stack 16 byte aligned (FIXME)
-#CFLAGS += -mpreferred-stack-boundary=2
+ifdef CONFIG_MK8
+CFLAGS += $(call check_gcc,-march=k8,)
+endif
+ifdef CONFIG_MPSC
+CFLAGS += $(call check_gcc,-march=nocona,)
+endif
 
 HEAD := arch/x86_64/kernel/head.o arch/x86_64/kernel/head64.o arch/x86_64/kernel/init_task.o
 
Index: arch/x86_64/config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/x86_64/config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/x86_64/config.in	22 Jul 2004 19:49:25 -0000	1.1
+++ arch/x86_64/config.in	4 Aug 2004 01:26:18 -0000	1.2
@@ -10,7 +10,7 @@
 define_bool CONFIG_ISA n
 define_bool CONFIG_SBUS n
 
-define_bool CONFIG_UID16 y
+define_bool CONFIG_UID16 n
 define_bool CONFIG_RWSEM_GENERIC_SPINLOCK y
 define_bool CONFIG_RWSEM_XCHGADD_ALGORITHM n
 define_bool CONFIG_X86_CMPXCHG y
@@ -34,13 +34,19 @@
 comment 'Processor type and features'
 choice 'Processor family' \
 	"AMD-Hammer			CONFIG_MK8 \
+	 Intel-x86-64			CONFIG_MPSC \
 	 Generic-x86-64			CONFIG_GENERIC_CPU" AMD-Hammer
 	
 #
 # Define implied options from the CPU selection here
 #
+if [ "$CONFIG_GENERIC_CPU" = "y" -o "$CONFIG_MPSC" = "y" ]; then
+define_int CONFIG_X86_L1_CACHE_BYTES 128
+define_int CONFIG_X86_L1_CACHE_SHIFT 7
+else
 define_int CONFIG_X86_L1_CACHE_BYTES 64
 define_int CONFIG_X86_L1_CACHE_SHIFT 6
+fi
 define_bool CONFIG_X86_TSC y
 define_bool CONFIG_X86_GOOD_APIC y
 
@@ -58,6 +64,9 @@
 bool 'Symmetric multi-processing support' CONFIG_SMP
 bool 'HPET timers' CONFIG_HPET_TIMER
 bool 'IOMMU support' CONFIG_GART_IOMMU
+if [ "$CONFIG_GART_IOMMU" = "y" ]; then
+    bool 'SWIOTLB support' CONFIG_SWIOTLB
+fi
 
 if [ "$CONFIG_GART_IOMMU" != "y" ]; then
    define_bool CONFIG_DUMMY_IOMMU y
@@ -66,13 +75,16 @@
    define_bool CONFIG_X86_UP_IOAPIC y
 else
    define_bool CONFIG_HAVE_DEC_LOCK y
+   int  'Maximum number of CPUs (2-8)' CONFIG_NR_CPUS 4
 fi
 
 bool 'Machine check support' CONFIG_MCE
-bool 'K8 NUMA support' CONFIG_K8_NUMA
-if [ "$CONFIG_K8_NUMA" = "y" ]; then
+if [ "$CONFIG_SMP" = "y" ]; then
+   bool 'K8 NUMA support' CONFIG_K8_NUMA
+   if [ "$CONFIG_K8_NUMA" = "y" ]; then
    define_bool CONFIG_DISCONTIGMEM y 
    define_bool CONFIG_NUMA y
+   fi
 fi
 
 endmenu
@@ -112,12 +124,7 @@
 
 bool 'IA32 Emulation' CONFIG_IA32_EMULATION
 
-if [ "$CONFIG_EXPERIMENTAL" = "y" ]; then
-   dep_bool '  ACPI support' CONFIG_ACPI $CONFIG_PM
-   if [ "$CONFIG_ACPI" != "n" ]; then
-      source drivers/acpi/Config.in
-   fi
-fi
+source drivers/acpi/Config.in
 
 endmenu
 
@@ -173,7 +180,7 @@
    if [ "$CONFIG_NETDEVICES" = "y" ]; then
       source drivers/net/Config.in
 # seems to be largely not 64bit safe	   
-#      if [ "$CONFIG_ATM" = "y" ]; then
+#      if [ "$CONFIG_ATM" = "y" -o "$CONFIG_ATM" = "m" ]; then
 #         source drivers/atm/Config.in
 #      fi
    fi
@@ -232,6 +239,8 @@
 
 source net/bluetooth/Config.in
 
+source crypto/Config.in
+
 mainmenu_option next_comment
 comment 'Kernel hacking'
 
@@ -247,6 +256,9 @@
    bool '  IOMMU leak tracing' CONFIG_IOMMU_LEAK
    bool '  Probalistic stack overflow check' CONFIG_DEBUG_STACKOVERFLOW
 fi
+
+int 'Kernel messages buffer length shift (0 = default)' CONFIG_LOG_BUF_SHIFT 0
+
 endmenu
 
 source lib/Config.in
Index: arch/x86_64/boot/setup.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/x86_64/boot/setup.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/x86_64/boot/setup.S	22 Jul 2004 19:49:26 -0000	1.1
+++ arch/x86_64/boot/setup.S	4 Aug 2004 01:26:19 -0000	1.2
@@ -289,8 +289,9 @@
 	/* minimum CPUID flags for x86-64 */
 	/* see http://www.x86-64.org/lists/discuss/msg02971.html */		
 #define SSE_MASK ((1<<25)|(1<<26))
-#define REQUIRED_MASK1 ((1<<0)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<8)|(1<<11)| \
-					   (1<<13)|(1<<15)|(1<<24)|(1<<29))
+#define REQUIRED_MASK1 ((1<<0)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<8)|\
+					   (1<<13)|(1<<15)|(1<<24))
+#define REQUIRED_MASK2 (1<<29)
 
 	pushfl				/* standard way to check for cpuid */
 	popl	%eax
@@ -302,10 +303,10 @@
 	popl	%eax
 	cmpl	%eax,%ebx
 	jz	no_longmode		/* cpu has no cpuid */
-	movl	$0x80000000,%eax
+	movl	$0x0,%eax
 	cpuid
-	cmpl	$0x80000001,%eax
-	jb	no_longmode		/* no extended cpuid */
+	cmpl	$0x1,%eax
+	jb	no_longmode		/* no cpuid 1 */
 	xor	%di,%di
 	cmpl	$0x68747541,%ebx	/* AuthenticAMD */
 	jnz	noamd
@@ -315,11 +316,20 @@
 	jnz	noamd
 	mov	$1,%di			/* cpu is from AMD */
 noamd:		
-	movl	$0x80000001,%eax		
+	movl    $0x1,%eax
 	cpuid
 	andl	$REQUIRED_MASK1,%edx
 	xorl	$REQUIRED_MASK1,%edx
 	jnz	no_longmode
+	movl    $0x80000000,%eax
+	cpuid
+	cmpl    $0x80000001,%eax
+	jb      no_longmode             /* no extended cpuid */
+	movl    $0x80000001,%eax
+	cpuid
+	andl    $REQUIRED_MASK2,%edx
+	xorl    $REQUIRED_MASK2,%edx
+	jnz     no_longmode
 sse_test:		
 	movl	$1,%eax
 	cpuid
@@ -347,6 +357,11 @@
 sse_ok:
 	popw	%ds
 	
+# tell BIOS we want to go to long mode
+	movl  $0xec00,%eax	# declare target operating mode
+	movl  $2,%ebx		# long mode
+	int $0x15			
+	
 # Get memory size (extended mem, kB)
 
 	xorl	%eax, %eax
@@ -519,7 +534,7 @@
 	cmpw	$0, %cs:realmode_swtch
 	jz	rmodeswtch_normal
 
-	lcall	%cs:realmode_swtch
+	lcall	*%cs:realmode_swtch
 
 	jmp	rmodeswtch_end
 
Index: arch/x86_64/boot/compressed/head.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/x86_64/boot/compressed/head.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/x86_64/boot/compressed/head.S	22 Jul 2004 19:49:26 -0000	1.1
+++ arch/x86_64/boot/compressed/head.S	4 Aug 2004 01:26:19 -0000	1.2
@@ -3,7 +3,7 @@
  *
  *  Copyright (C) 1991, 1992, 1993  Linus Torvalds
  *
- *  $Id: head.S,v 1.1 2004/07/22 19:49:26 joff Exp $	 		
+ *  $Id: head.S,v 1.2 2004/08/04 01:26:19 joff Exp $	 		
  */
 
 /*
Index: arch/x86_64/boot/tools/build.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/x86_64/boot/tools/build.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/x86_64/boot/tools/build.c	22 Jul 2004 19:49:26 -0000	1.1
+++ arch/x86_64/boot/tools/build.c	4 Aug 2004 01:26:19 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- *  $Id: build.c,v 1.1 2004/07/22 19:49:26 joff Exp $
+ *  $Id: build.c,v 1.2 2004/08/04 01:26:19 joff Exp $
  *
  *  Copyright (C) 1991, 1992  Linus Torvalds
  *  Copyright (C) 1997 Martin Mares
Index: arch/x86_64/ia32/fpu32.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/x86_64/ia32/fpu32.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/x86_64/ia32/fpu32.c	22 Jul 2004 19:49:26 -0000	1.1
+++ arch/x86_64/ia32/fpu32.c	4 Aug 2004 01:26:19 -0000	1.2
@@ -2,7 +2,7 @@
  * Copyright 2002 Andi Kleen, SuSE Labs.
  * FXSAVE<->i387 conversion support. Based on code by Gareth Hughes.
  * This is used for ptrace, signals and coredumps in 32bit emulation.
- * $Id: fpu32.c,v 1.1 2004/07/22 19:49:26 joff Exp $
+ * $Id: fpu32.c,v 1.2 2004/08/04 01:26:19 joff Exp $
  */ 
 
 #include <linux/sched.h>
Index: arch/x86_64/ia32/ia32_binfmt.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/x86_64/ia32/ia32_binfmt.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/x86_64/ia32/ia32_binfmt.c	22 Jul 2004 19:49:26 -0000	1.1
+++ arch/x86_64/ia32/ia32_binfmt.c	4 Aug 2004 01:26:19 -0000	1.2
@@ -12,6 +12,7 @@
 #include <linux/rwsem.h>
 #include <linux/sched.h>
 #include <linux/string.h>
+#include <linux/personality.h>
 #include <asm/segment.h> 
 #include <asm/ptrace.h>
 #include <asm/processor.h>
@@ -27,7 +28,6 @@
 
 #define ELF_NAME "elf/i386"
 
-#define IA32_PAGE_OFFSET 0xFFFFe000
 #define IA32_STACK_TOP IA32_PAGE_OFFSET
 #define ELF_ET_DYN_BASE		(IA32_PAGE_OFFSET/3 + 0x1000000)
 
@@ -162,7 +162,7 @@
 # define CONFIG_BINFMT_ELF_MODULE	CONFIG_BINFMT_ELF32_MODULE
 #endif
 
-#define ELF_PLAT_INIT(r)		elf32_init(r)
+#define ELF_PLAT_INIT(r, load_addr)	elf32_init(r)
 #define setup_arg_pages(bprm)		ia32_setup_arg_pages(bprm)
 
 extern void load_gs_index(unsigned);
@@ -243,8 +243,9 @@
 		mpnt->vm_mm = current->mm;
 		mpnt->vm_start = PAGE_MASK & (unsigned long) bprm->p;
 		mpnt->vm_end = IA32_STACK_TOP;
-		mpnt->vm_page_prot = PAGE_COPY_EXEC;
-		mpnt->vm_flags = VM_STACK_FLAGS;
+		mpnt->vm_flags = vm_stack_flags32; 
+		mpnt->vm_page_prot = (mpnt->vm_flags & VM_EXEC) ? 
+			PAGE_COPY_EXEC : PAGE_COPY;
 		mpnt->vm_ops = NULL;
 		mpnt->vm_pgoff = 0;
 		mpnt->vm_file = NULL;
